﻿--PoisonerMenu:Hide();
--PoisonerOptions_SettingsFrame:Hide();
Poisoner_SecureHandler = {}

local btnMinimap = CreateFrame("BUTTON", "Poisoner_FreeButton", UIParent, "SecureHandlerClickTemplate, SecureHandlerBaseTemplate, Poisoner_MinimapButton");
btnMinimap:RegisterForDrag("LeftButton");
--btnMinimap:SetClampedToScreen(true);
btnMinimap:ClearAllPoints();
btnMinimap:SetPoint("CENTER",UIParent,"CENTER");

local texture = btnMinimap:CreateTexture(nil, "ARTWORK");
texture:SetTexture("Interface\\AddOns\\Poisoner\\images\\Poisoner_MMButton");
texture:SetBlendMode("BLEND");
texture:SetAllPoints(btnMinimap);
btnMinimap:SetHighlightTexture(texture);
Poisoner_TestTableInterger = {"Test-1","Test-2","Test-3"}
--[[
btnMinimap:SetAttribute("_onclick", [=[
 local show, i, ref = button == "LeftButton", 2, self:GetFrameRef("frame1");
 while ref do
  if show then ref:Show(); else ref:Hide(); end
  i, ref = i + 1, self:GetFrameRef("frame" .. i);
 end
]=]);
]]
btnMinimap:Execute([[
	poisons = table.new();
	
	Show = [=[
		print("Standard Execute - Show")
	]=]
	
	print("Standard Execute")
]]);
btnMinimap:SetAttribute("_onclick", [=[
 local left, right, menu, options, qb = button == "LeftButton", button == "RightButton", self:GetFrameRef("frame1"), self:GetFrameRef("frame2"), self:GetFrameRef("button1");
	
	if right then
		if options:IsVisible() then
				options:Hide();
		elseif options:IsShown() then
			options:Hide();
		else
			options:Show();
		end
	else
		if menu:IsVisible() then
			menu:Hide();
		elseif menu:IsShown() then
			menu:Hide();
		else
			menu:Show();
		end
	end
	--print("Standard _onclick")
	--print(qb:GetName())
	--qb:Show()
	
	local poison1, poison2, poison3, poison4, poison5, poison6, poison7, poison8, poison9, poison10, poison11, poison12
	poison1 = poisons[1]:GetAttribute("Text")
	poison2 = poisons[2]:GetAttribute("Text")
	poison3 = poisons[3]:GetAttribute("Text")
	poison4 = poisons[4]:GetAttribute("Text")
	poison5 = poisons[5]:GetAttribute("Text")
	poison6 = poisons[6]:GetAttribute("Text")
	poison7 = poisons[7]:GetAttribute("Text")
	poison8 = poisons[8]:GetAttribute("Text")
	poison9 = poisons[9]:GetAttribute("Text")
	poison10 = poisons[10]:GetAttribute("Text")
	poison11 = poisons[11]:GetAttribute("Text")
	poison12 = poisons[12]:GetAttribute("Text")
	
	--Poisoner_QuickButton_Text = "/use [nomodifier,button:3] "..poison9.."\n/use [modifier:shift,button:3] "..poison10.."\n/use [modifier:ctrl,button:3] "..poison11.."\n/use [modifier:alt,button:3] "..poison12.."\n/use [button:3] 18\n/use [nomodifier,button:2] "..poison5.."\n/use [modifier:shift,button:2] "..poison6.."\n/use [modifier:ctrl,button:2] "..poison7.."\n/use [modifier:alt,button:2] "..poison8.."\n/use [button:2] 17\n/use [nomodifier,button:1] "..poison1.."\n/use [modifier:shift,button:1] "..poison2.."\n/use [modifier:ctrl,button:1] "..poison3.."\n/use [modifier:alt,button:1] "..poison4.."\n/use [button:1] 16\n/click StaticPopup1Button1\n/run PoisonerOptions_CheckPoisons()"
	--print(Poisoner_QuickButton_Text)	
	qb:SetAttribute("type", "macro");
	--qb:SetAttribute("macrotext", "TEST");
	qb:SetAttribute("macrotext", "/use [nomodifier,button:3] "..poison9.."\n/use [modifier:shift,button:3] "..poison10.."\n/use [modifier:ctrl,button:3] "..poison11.."\n/use [modifier:alt,button:3] "..poison12.."\n/use [button:3] 18\n/use [nomodifier,button:2] "..poison5.."\n/use [modifier:shift,button:2] "..poison6.."\n/use [modifier:ctrl,button:2] "..poison7.."\n/use [modifier:alt,button:2] "..poison8.."\n/use [button:2] 17\n/use [nomodifier,button:1] "..poison1.."\n/use [modifier:shift,button:1] "..poison2.."\n/use [modifier:ctrl,button:1] "..poison3.."\n/use [modifier:alt,button:1] "..poison4.."\n/use [button:1] 16\n/click StaticPopup1Button1\n/run PoisonerOptions_CheckPoisons()");
	
	
]=]);

	--[[Poisoner_PoisonSlots = {
		Poisoner_Poison16,
		Poisoner_Poison16_SHIFT,
		Poisoner_Poison16_CTRL,
		Poisoner_Poison16_ALT,
		Poisoner_Poison17,
		Poisoner_Poison17_SHIFT,
		Poisoner_Poison17_CTRL,
		Poisoner_Poison17_ALT,
		Poisoner_Poison18,
		Poisoner_Poison18_SHIFT,
		Poisoner_Poison18_CTRL,
		Poisoner_Poison18_ALT,
	}]]

btnMinimap:RegisterForClicks("AnyUp");
btnMinimap:SetFrameRef("frame1", PoisonerMenu);
btnMinimap:SetFrameRef("frame2", PoisonerOptions_SettingsFrame);
btnMinimap:SetFrameRef("button1", Poisoner_QuickButton);


btnMinimap:SetScript("OnDragStart", Poisoner_OnDragStart);
btnMinimap:SetScript("OnDragStop", Poisoner_OnDragStop);

btnMinimap:SetScript("OnEvent", function(self, event, ...)
	if (type(Poisoner_SecureHandler[event]) == 'function') then
		Poisoner_SecureHandler[event](self, event, ...);
	end
end)
btnMinimap:RegisterEvent("VARIABLES_LOADED");

function Poisoner_SecureHandler:VARIABLES_LOADED(self, event)
	--Poisoner_SecureHandler:PositionMinimapButton();
	local _, cls = UnitClass("player");
	if --[[(cls == "ROGUE") and (POISONER_CONFIG) and]] (POISONER_CONFIG.Enabled == 1) then
		Poisoner_SecureHandler:LoadMenu();
	end
	
end

function Poisoner_SecureHandler:LoadMenu()
	btnMinimap:Execute([[
		poisons = table.new();
	]]);
	Poisoner_TestTable = {}
	local poisonslots = Poisoner_PoisonSlots;
	local index = 1
	for k,v in pairs(poisonslots) do
		local text = v.Name
		btnMinimap:Execute([[
			table.insert(poisons, text);
		]]);
		table.insert(Poisoner_TestTable, index, text);
		--print("poisons "..index)
		--print(v.Name.." - "..v.Texture)
		index = index + 1
	end
	
	for index = 1, table.getn(poisonslots) do 
		local section = poisonslots[index];
			
		--Create section header
		btnMenuItem = _G["Poisoner_PoisonSlotFrame"..index];
		if (not btnMenuItem) then
			btnMenuItem = CreateFrame("Button", "Poisoner_PoisonSlotFrame"..index, PoisonerStateHeader, "SecureHandlerBaseTemplate, Poisoner_MenuLabelTemplate");
		end
		btnMenuItem:SetText(section.Name);
		btnMenuItem:SetAttribute("Text", section.Name)
		btnMenuItem:SetFrameRef("button1", Poisoner_QuickButton);
		btnMenuItem:Show();
		btnMinimap:SetFrameRef("child", btnMenuItem);
		btnMinimap:Execute([[
			table.insert(poisons, self:GetFrameRef("child"));
		]]);
	end	
	
end


function Poisoner_FreeButton_Update()

btnMinimap:SetAttribute("_onclick", [=[
 local left, right, menu, options, qb = button == "LeftButton", button == "RightButton", self:GetFrameRef("frame1"), self:GetFrameRef("frame2"), self:GetFrameRef("button1");
	
	if right then
		if options:IsVisible() then
				options:Hide();
		elseif options:IsShown() then
			options:Hide();
		else
			options:Show();
		end
	else
		if menu:IsVisible() then
			menu:Hide();
		elseif menu:IsShown() then
			menu:Hide();
		else
			menu:Show();
		end
	end
	
	print("Updated _onclick")
		
	--print(unpack(poisons))

	local poison16 = _G["Poisoner_PoisonSlotFrame1"]:GetAttribute("Text");
	local poison16shift = _G["Poisoner_PoisonSlotFrame2"]:GetAttribute("Text");
	local poison16ctrl = _G["Poisoner_PoisonSlotFrame3"]:GetAttribute("Text");
	local poison16alt = _G["Poisoner_PoisonSlotFrame4"]:GetAttribute("Text");
	
	local poison17 = _G["Poisoner_PoisonSlotFrame5"]:GetAttribute("Text");
	local poison17shift = _G["Poisoner_PoisonSlotFrame6"]:GetAttribute("Text");
	local poison17ctrl = _G["Poisoner_PoisonSlotFrame7"]:GetAttribute("Text");
	local poison17alt = _G["Poisoner_PoisonSlotFrame8"]:GetAttribute("Text");
	
	local poison18 = _G["Poisoner_PoisonSlotFrame9"]:GetAttribute("Text");
	local poison18shift = _G["Poisoner_PoisonSlotFrame10"]:GetAttribute("Text");
	local poison18ctrl = _G["Poisoner_PoisonSlotFrame11"]:GetAttribute("Text");
	local poison18alt = _G["Poisoner_PoisonSlotFrame12"]:GetAttribute("Text");
	
	qb:SetAttribute("type", "macro");
	qb:SetAttribute("macrotext", "/use [nomodifier,button:3] "..poison18.."\n/use [modifier:shift,button:3] "..poison18shift.."\n/use [modifier:ctrl,button:3] "..poison18ctrl.."\n/use [modifier:alt,button:3] "..poison18alt.."\n/use [button:3] 18\n/use [nomodifier,button:2] "..poison17.."\n/use [modifier:shift,button:2] "..poison17shift.."\n/use [modifier:ctrl,button:2] "..poison17ctrl.."\n/use [modifier:alt,button:2] "..poison17alt.."\n/use [button:2] 17\n/use [nomodifier,button:1] "..poison16.."\n/use [modifier:shift,button:1] "..poison16shift.."\n/use [modifier:ctrl,button:1] "..poison16ctrl.."\n/use [modifier:alt,button:1] "..poison16alt.."\n/use [button:1] 16\n/click StaticPopup1Button1\n/run PoisonerOptions_CheckPoisons()");
	
]=]);

end